﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace ComboboxColumn
{
    public class MyViewModel : INotifyPropertyChanged

    {
        public ICommand IsChangedCommand { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        private Pilot selectedPilot;

        public Pilot SelectedPilot
        {
            get
            {
                return selectedPilot;
            }
            set
            {
                this.selectedPilot = value;
                this.OnPropertyChanged("SelectedPilot");
            }
        }


        private ObservableCollection<Pilot> pilots;
        private ObservableCollection<Country> countries;

        public ObservableCollection<Pilot> Pilots
        {
            get
            {
                if (this.pilots == null)
                {
                    this.pilots = Pilot.GetPilots();
                }

                return this.pilots;
            }
        }

        public ObservableCollection<Country> Countries
        {
            get
            {
                if (this.countries == null)
                {
                    this.countries = Country.GetCountries();
                }

                return this.countries;
            }
        }

        public MyViewModel()
        {
            this.IsChangedCommand = new DelegateCommand(onIsChangedCommand);
        }

        private void onIsChangedCommand(object obj)
        {
            var item = (obj as GridViewRowEditEndedEventArgs).NewData;
            this.SelectedPilot = item as Pilot;

        }

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
